
#line 453 "../../blib/lib/PDL/PP.pm"
/*
 * THIS FILE WAS GENERATED BY PDL::PP from imagend.pd! Do not modify!
 */

#define PDL_COMMENT(comment)
PDL_COMMENT("This preprocessor symbol is used to add commentary in the PDL  ")
PDL_COMMENT("autogenerated code. Normally, one would use typical C-style    ")
PDL_COMMENT("multiline comments (i.e. /* comment */). However, because such ")
PDL_COMMENT("comments do not nest, it's not possible for PDL::PP users to   ")
PDL_COMMENT("comment-out sections of code using multiline comments, as is   ")
PDL_COMMENT("often the practice when debugging, for example. So, when you   ")
PDL_COMMENT("see something like this:                                       ")
PDL_COMMENT("                                                               ")
                PDL_COMMENT("Memory access")
PDL_COMMENT("                                                               ")
PDL_COMMENT("just think of it as a C multiline comment like:                ")
PDL_COMMENT("                                                               ")
PDL_COMMENT("   /* Memory access */                                         ")

#define PDL_FREE_CODE(trans, destroy, comp_free_code, ntpriv_free_code) \
    if (destroy) { \
	comp_free_code \
    } \
    if ((trans)->dims_redone) { \
	ntpriv_free_code \
    }

#include "EXTERN.h"
#include "perl.h"
#include "XSUB.h"
#include "pdl.h"
#include "pdlcore.h"
#define PDL PDL_ImageND
extern Core* PDL; PDL_COMMENT("Structure hold core C functions")
#line 38 "ImageND.xs"

/* Compute offset of (x,y,z,...) position in row-major list */

static inline PDL_Indx ndim_get_offset(PDL_Indx* pos, PDL_Indx* dims, PDL_Long ndims) {
   PDL_Long i;
   PDL_Indx result,size;
   size = 1;
   result = 0;
   for (i=0; i<ndims; i++) {
       if (i>0)
          size = size*dims[i-1];
       result = result + pos[i]*size;
   }
   return result;
}

/* Increment a position pointer array by one row */

static inline void ndim_row_plusplus ( PDL_Indx* pos, PDL_Indx* dims, PDL_Long ndims ) {

    PDL_Long  noescape;
    PDL_Indx i;

    i=1; noescape=1;

    while(noescape) {

       (pos[i])++;

       if (pos[i]==dims[i]) { /* Carry */
          if (i>=(ndims)-1)  {
             noescape = 0; /* Exit */
          }else{
             pos[i]=0;
             i++;
          }
       }else{
          noescape = 0;    /* Exit */
       }
    }
}

pdl_error pdl_run_convolve(pdl  *a,pdl  *b,pdl  *adims,pdl  *bdims,pdl  *c);
pdl_error pdl_run_rebin(pdl  *a,pdl  *b,int  ns);
pdl_error pdl_run_convolveND(pdl  *k0,pdl  *k,pdl  *aa,pdl  *a);
pdl_error pdl_run_contour_segments(pdl  *c,pdl  *data,pdl  *points,pdl  *segs,pdl  *cnt);
pdl_error pdl_run_contour_polylines(pdl  *c,pdl  *data,pdl  *points,pdl  *pathendindex,pdl  *paths);
pdl_error pdl_run_path_join(pdl  *e,pdl  *pathendindex,pdl  *paths,PDL_Indx  d,int  directed);

#line 449 "../../blib/lib/PDL/PP.pm"
#include "pdlperl.h"
#line 90 "ImageND.xs"

Core* PDL = NULL; PDL_COMMENT("Structure hold core C functions")

MODULE = PDL::ImageND PACKAGE = PDL PREFIX=pdl_run_

PROTOTYPES: DISABLE


NO_OUTPUT pdl_error
_convolve_int(a,b,adims,bdims,c)
  pdl  *a
  pdl  *b
  pdl  *adims
  pdl  *bdims
  pdl  *c
 CODE:
  RETVAL = pdl_run_convolve(a,b,adims,bdims,c);
  PDL->barf_if_error(RETVAL);

NO_OUTPUT pdl_error
_rebin_int(a,b,ns)
  pdl  *a
  pdl  *b
  int  ns
 CODE:
  RETVAL = pdl_run_rebin(a,b,ns);
  PDL->barf_if_error(RETVAL);

NO_OUTPUT pdl_error
_convolveND_int(k0,k,aa,a)
  pdl  *k0
  pdl  *k
  pdl  *aa
  pdl  *a
 CODE:
  RETVAL = pdl_run_convolveND(k0,k,aa,a);
  PDL->barf_if_error(RETVAL);

NO_OUTPUT pdl_error
pdl_run_contour_segments(c, data, points, segs=PDL_XS_PERLINIT_initsv(segs_SV), cnt=PDL_XS_PERLINIT_initsv(cnt_SV))
  SV *segs_SV = items > 3 ? ST(3) : NULL;
  SV *cnt_SV = items > 4 ? ST(4) : NULL;
 PREINIT:
  PDL_XS_PREAMBLE((items == 5) ? 0 : 2);
 INPUT:
  pdl *c
  pdl *data
  pdl *points
  pdl *segs
  pdl *cnt
 PPCODE:
  RETVAL = pdl_run_contour_segments(c,data,points,segs,cnt);
  PDL->barf_if_error(RETVAL);
  PDL_XS_RETURN(ST(0) = segs_SV;ST(1) = cnt_SV)

NO_OUTPUT pdl_error
pdl_run_contour_polylines(c, data, points, pathendindex=PDL_XS_PERLINIT_initsv(pathendindex_SV), paths=PDL_XS_PERLINIT_initsv(paths_SV))
  SV *pathendindex_SV = items > 3 ? ST(3) : NULL;
  SV *paths_SV = items > 4 ? ST(4) : NULL;
 PREINIT:
  PDL_XS_PREAMBLE((items == 5) ? 0 : 2);
 INPUT:
  pdl *c
  pdl *data
  pdl *points
  pdl *pathendindex
  pdl *paths
 PPCODE:
  RETVAL = pdl_run_contour_polylines(c,data,points,pathendindex,paths);
  PDL->barf_if_error(RETVAL);
  PDL_XS_RETURN(ST(0) = pathendindex_SV;ST(1) = paths_SV)

NO_OUTPUT pdl_error
pdl_run_path_join(e, pathendindex=pathendindex, paths=paths, d=d, directed=directed)
  SV *pathendindex_SV = (items == 5) ? ST(1) : NULL;
  SV *paths_SV = (items == 5) ? ST(2) : NULL;
  SV *d_SV = (items == 5) ? ST(3) : ST(1);
  SV *directed_SV = (items == 5) ? ST(4) : !(items == (3-1)) ? ST(2) : NULL;
 PREINIT:
  PDL_XS_PREAMBLE((items == 5) ? 0 : 2);
  if (!((items == (3-1)) || (items == 3) || (items == 5)))
    croak("Usage: PDL::path_join(e,[pathendindex],[paths],d,directed=1) (you may leave [outputs] and values with =defaults out of list)");
 INPUT:
  pdl *e
  pdl *pathendindex=NO_INIT
  pdl *paths=NO_INIT
  PDL_Indx  d; { d = (PDL_Indx)SvIV(d_SV); }
  int  directed=NO_INIT
 PPCODE:
  if (!directed_SV) { directed = (1); } else { directed = (int)SvIV(directed_SV); }
  if (pathendindex_SV) { pathendindex = PDL_CORE_(SvPDLV)(pathendindex_SV); } else pathendindex = PDL_XS_PERLINIT_initsv(pathendindex_SV);
  if (paths_SV) { paths = PDL_CORE_(SvPDLV)(paths_SV); } else paths = PDL_XS_PERLINIT_initsv(paths_SV);
  RETVAL = pdl_run_path_join(e,pathendindex,paths,d,directed);
  PDL->barf_if_error(RETVAL);
  PDL_XS_RETURN(ST(0) = pathendindex_SV;ST(1) = paths_SV)


#line 498 "../../blib/lib/PDL/PP.pm"
BOOT:
   PDL_COMMENT("Get pointer to structure of core shared C routines")
   PDL_COMMENT("make sure PDL::Core is loaded")
#line 192 "ImageND.xs"
   perl_require_pv ("PDL/Core.pm"); /* make sure PDL::Core is loaded */
#ifndef aTHX_
#define aTHX_
#endif
   if (SvTRUE (ERRSV)) Perl_croak(aTHX_ "%s",SvPV_nolen (ERRSV));
   SV* CoreSV = perl_get_sv("PDL::SHARE",FALSE); /* var with core structure */
   if (!CoreSV)
     Perl_croak(aTHX_ "We require the PDL::Core module, which was not found");
   if (!(PDL = INT2PTR(Core*,SvIV( CoreSV )))) /* Core* value */
     Perl_croak(aTHX_ "Got NULL pointer for PDL");
   if (PDL->Version != PDL_CORE_VERSION)
     Perl_croak(aTHX_ "[PDL->Version: %ld PDL_CORE_VERSION: %ld XS_VERSION: %s] PDL::ImageND needs to be recompiled against the newly installed PDL", (long int)PDL->Version, (long int)PDL_CORE_VERSION, XS_VERSION);
